"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports["default"]=exports.useFirebaseUploads=exports.TaskStatus=void 0;var _react=_interopRequireWildcard(require("react"));var _propTypes=_interopRequireDefault(require("prop-types"));var _immutable=require("immutable");var _reactUseMutator=require("react-use-mutator");var _v=_interopRequireDefault(require("uuid/v4"));var _reactNativeMimeTypes=require("react-native-mime-types");var _storage=_interopRequireDefault(require("@react-native-firebase/storage"));function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _getRequireWildcardCache(){if(typeof WeakMap!=="function")return null;var cache=new WeakMap;_getRequireWildcardCache=function _getRequireWildcardCache(){return cache};return cache}function _interopRequireWildcard(obj){if(obj&&obj.__esModule){return obj}if(obj===null||_typeof(obj)!=="object"&&typeof obj!=="function"){return{default:obj}}var cache=_getRequireWildcardCache();if(cache&&cache.has(obj)){return cache.get(obj)}var newObj={};var hasPropertyDescriptor=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var key in obj){if(Object.prototype.hasOwnProperty.call(obj,key)){var desc=hasPropertyDescriptor?Object.getOwnPropertyDescriptor(obj,key):null;if(desc&&(desc.get||desc.set)){Object.defineProperty(newObj,key,desc)}else{newObj[key]=obj[key]}}}newObj["default"]=obj;if(cache){cache.set(obj,newObj)}return newObj}function _slicedToArray(arr,i){return _arrayWithHoles(arr)||_iterableToArrayLimit(arr,i)||_nonIterableRest()}function _nonIterableRest(){throw new TypeError("Invalid attempt to destructure non-iterable instance")}function _iterableToArrayLimit(arr,i){if(!(Symbol.iterator in Object(arr)||Object.prototype.toString.call(arr)==="[object Arguments]")){return}var _arr=[];var _n=true;var _d=false;var _e=undefined;try{for(var _i=arr[Symbol.iterator](),_s;!(_n=(_s=_i.next()).done);_n=true){_arr.push(_s.value);if(i&&_arr.length===i)break}}catch(err){_d=true;_e=err}finally{try{if(!_n&&_i["return"]!=null)_i["return"]()}finally{if(_d)throw _e}}return _arr}function _arrayWithHoles(arr){if(Array.isArray(arr))return arr}function _objectWithoutProperties(source,excluded){if(source==null)return{};var target=_objectWithoutPropertiesLoose(source,excluded);var key,i;if(Object.getOwnPropertySymbols){var sourceSymbolKeys=Object.getOwnPropertySymbols(source);for(i=0;i<sourceSymbolKeys.length;i++){key=sourceSymbolKeys[i];if(excluded.indexOf(key)>=0)continue;if(!Object.prototype.propertyIsEnumerable.call(source,key))continue;target[key]=source[key]}}return target}function _objectWithoutPropertiesLoose(source,excluded){if(source==null)return{};var target={};var sourceKeys=Object.keys(source);var key,i;for(i=0;i<sourceKeys.length;i++){key=sourceKeys[i];if(excluded.indexOf(key)>=0)continue;target[key]=source[key]}return target}function _typeof(obj){"@babel/helpers - typeof";if(typeof Symbol==="function"&&typeof Symbol.iterator==="symbol"){_typeof=function _typeof(obj){return typeof obj}}else{_typeof=function _typeof(obj){return obj&&typeof Symbol==="function"&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj}}return _typeof(obj)}function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);if(enumerableOnly)symbols=symbols.filter(function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable});keys.push.apply(keys,symbols)}return keys}function _objectSpread(target){for(var i=1;i<arguments.length;i++){var source=arguments[i]!=null?arguments[i]:{};if(i%2){ownKeys(Object(source),true).forEach(function(key){_defineProperty(target,key,source[key])})}else if(Object.getOwnPropertyDescriptors){Object.defineProperties(target,Object.getOwnPropertyDescriptors(source))}else{ownKeys(Object(source)).forEach(function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key))})}}return target}function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true})}else{obj[key]=value}return obj}var TaskStatus={CREATED:0,UPLOADING:1,FINISHED:2,ERROR:3};exports.TaskStatus=TaskStatus;var UploadProviderError=Object.freeze(new Error("It looks like you haven't declared a FirebaseUploadProvider at the root of your application."));var defaultMimeTypes=Object.freeze([]);var defaultContext=Object.freeze({useUploads:function useUploads(){throw UploadProviderError},requestUpload:function requestUpload(){return Promise.reject(UploadProviderError)}});var FirebaseUploadContext=_react["default"].createContext(defaultContext);var useFirebaseUploads=function useFirebaseUploads(){return _react["default"].useContext(FirebaseUploadContext)};exports.useFirebaseUploads=useFirebaseUploads;var createTask=function createTask(uri,mimeType){return Object.freeze({status:TaskStatus.CREATED,uri:uri,mimeType:mimeType,bytesTransferred:0,totalBytes:undefined})};var updateTaskStatus=function updateTaskStatus(task,status){return Object.freeze(_objectSpread({},task,{status:status}))};var updateTaskProgress=function updateTaskProgress(task,bytesTransferred,totalBytes){return Object.freeze(_objectSpread({},task,{bytesTransferred:bytesTransferred,totalBytes:totalBytes}))};var publishTaskUpdates=function publishTaskUpdates(uploadTask,mutate,uploadId){var unsubscribe=uploadTask.on(_storage["default"].TaskEvent.STATE_CHANGED,function(snapshot){var state=snapshot.state,bytesTransferred=snapshot.bytesTransferred,totalBytes=snapshot.totalBytes;mutate(function(state){return state.set(uploadId,updateTaskProgress(state.get(uploadId),bytesTransferred,totalBytes))});if(state===_storage["default"].TaskState.SUCCESS){unsubscribe()}},function(err){return unsubscribe()})};var shouldUpload=function shouldUpload(uploadId,mutate,createRef){return Promise.resolve().then(function(){var currentState=mutate();var taskState=currentState.get(uploadId);if(!!taskState&&_typeof(taskState)==="object"){var status=taskState.status;if(status===TaskStatus.CREATED||status===TaskStatus.ERROR){var nextTaskState=updateTaskStatus(taskState,TaskStatus.UPLOADING);mutate(function(state){return state.set(uploadId,nextTaskState)});return Promise.resolve(nextTaskState)}return Promise.reject(new Error("This task is not in the correct state to be uploaded."))}return Promise.reject(new Error('Attempted to upload an unrecogized uploadId, "'.concat(uploadId,'".')))}).then(function(taskState){var uri=taskState.uri,contentType=taskState.mimeType;var ref=createRef(uploadId,taskState);var uploadTask=ref.putFile(uri,{contentType:contentType});publishTaskUpdates(uploadTask,mutate,uploadId);return uploadTask}).then(function(uploadResult){mutate(function(state){return state.set(uploadId,updateTaskStatus(state.get(uploadId),TaskStatus.FINISHED))});return Promise.resolve(uploadResult)})["catch"](function(e){mutate(function(state){return state.set(uploadId,updateTaskStatus(state.get(uploadId),TaskStatus.ERROR))});return Promise.reject(e)})};var requestUploadThunk=function requestUploadThunk(mutate,supportedMimeTypes,createRef){return function(uri){var customCreateRef=arguments.length>1&&arguments[1]!==undefined?arguments[1]:null;var mimeType=(0,_reactNativeMimeTypes.lookup)(uri);if(typeof uri!=="string"||uri.length===0){throw new Error("Expected valid uri, encountered ".concat(uri,"."))}else if(typeof mimeType!=="string"||mimeType.length===0){throw new Error("Expected valid mimeType, encountered ".concat(mimeType,"."))}else if(supportedMimeTypes.indexOf(mimeType)<0){throw new Error("Mime Type ".concat(mimeType," is not supported. You can add this to the supportedMimeTypes prop of your provider if you wish to support kind of content."))}var uploadId=(0,_v["default"])();mutate(function(state){return state.set(uploadId,createTask(uri,mimeType))});return[uploadId,function(){return shouldUpload(uploadId,mutate,customCreateRef||createRef)}]}};var FirebaseUploadProvider=function FirebaseUploadProvider(_ref){var supportedMimeTypes=_ref.supportedMimeTypes,createRef=_ref.createRef,extraProps=_objectWithoutProperties(_ref,["supportedMimeTypes","createRef"]);var _useMutator=(0,_reactUseMutator.useMutator)(function(){return(0,_immutable.Map)()}),_useMutator2=_slicedToArray(_useMutator,2),useUploads=_useMutator2[0],mutate=_useMutator2[1];var _useState=(0,_react.useState)(function(){return requestUploadThunk(mutate,supportedMimeTypes,createRef)}),_useState2=_slicedToArray(_useState,1),requestUpload=_useState2[0];return _react["default"].createElement(FirebaseUploadContext.Provider,{value:{requestUpload:requestUpload,useUploads:useUploads}},_react["default"].createElement(_react["default"].Fragment,extraProps))};FirebaseUploadProvider.propTypes={supportedMimeTypes:_propTypes["default"].arrayOf(_propTypes["default"].string),createRef:_propTypes["default"].func};FirebaseUploadProvider.defaultProps={supportedMimeTypes:defaultMimeTypes,createRef:function createRef(taskId,_ref2){var mimeType=_ref2.mimeType;return(0,_storage["default"])().ref(mimeType.substring(0,mimeType.indexOf("/"))).child(taskId)}};var _default=FirebaseUploadProvider;exports["default"]=_default;